Index: java/main/src/main/java/com/framsticks/core/Instance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Instance.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/Instance.java	(revision 84)
@@ -3,5 +3,4 @@
 import com.framsticks.communication.*;
 import com.framsticks.params.*;
-import com.framsticks.params.types.CompositeParam;
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.parsers.Loaders;
@@ -9,4 +8,7 @@
 import com.framsticks.util.*;
 import com.framsticks.util.UnsupportedOperationException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Future;
+import com.framsticks.util.lang.Casting;
 import org.apache.log4j.Logger;
 
@@ -18,28 +20,22 @@
 public abstract class Instance extends Entity {
 
-	private static final Logger LOGGER = Logger.getLogger(Instance.class.getName());
-
-
-    protected Node root;
-
-    public Set<InstanceListener> listeners = new HashSet<InstanceListener>();
-
-    public Instance(Parameters parameters) {
-        super(parameters);
-        root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o").build(), null);
-	}
-
-    @Override
-    protected void run() {
-        super.run();
+	private static final Logger log = Logger.getLogger(Instance.class.getName());
+
+
+	protected Node root;
+
+	public Set<InstanceListener> listeners = new HashSet<InstanceListener>();
+
+	public Instance() {
+	}
+
+	@Override
+	protected void run() {
+		super.run();
+		root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o").build(), null);
 		com.framsticks.model.Package.register(registry);
-    }
-
-    @Override
-    protected void configure() throws Exception {
-        super.configure();
-    }
-
-    protected void fetchInfo(Path path, Future<FramsClass> future) {
+	}
+
+	protected void fetchInfo(Path path, Future<FramsClass> future) {
 		future.result(null, new UnsupportedOperationException());
 	}
@@ -61,13 +57,13 @@
 	}
 
-    public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
+	public void fetchValue(Path path, Param param, StateFunctor stateFunctor) {
 		stateFunctor.call(null);
 	}
 
-    public void fetchValues(Path path, StateFunctor stateFunctor) {
+	public void fetchValues(Path path, StateFunctor stateFunctor) {
 		stateFunctor.call(null);
 	}
 
-    protected void tryRegisterOnChangeEvents(Path path) {
+	protected void tryRegisterOnChangeEvents(Path path) {
 
 	}
@@ -83,52 +79,59 @@
 	}
 
-    protected void fireRun(Exception e) {
-        for (InstanceListener l : this.listeners) {
-            l.onRun(e);
-        }
-    }
-
-    protected void fireStop(Exception e) {
-        for (InstanceListener l : this.listeners) {
-            l.onStop(e);
-        }
-    }
-
-    public void addListener(final InstanceListener listener) {
-        assert Dispatching.isThreadSafe();
-        Dispatching.invokeLaterOrNow(this, new Runnable() {
-            @Override
-            public void run() {
-                listeners.add(listener);
-            }
-        });
-    }
-
-    public void removeListener(final InstanceListener listener) {
-        assert Dispatching.isThreadSafe();
-        Dispatching.invokeLaterOrNow(this, new Runnable() {
-            @Override
-            public void run() {
-                listeners.remove(listener);
-            }
-        });
-    }
-
-
-    protected void fireListChange(Path path, ListChange change) {
-        assert isActive();
-        for (InstanceListener l : this.listeners) {
+	protected void fireRun(Exception e) {
+		for (InstanceListener l : this.listeners) {
+			l.onRun(e);
+		}
+	}
+
+	protected void fireStop(Exception e) {
+		for (InstanceListener l : this.listeners) {
+			l.onStop(e);
+		}
+	}
+
+	public void addListener(final InstanceListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.invokeLaterOrNow(this, new Runnable() {
+			@Override
+			public void run() {
+				listeners.add(listener);
+			}
+		});
+	}
+
+	public void removeListener(final InstanceListener listener) {
+		assert Dispatching.isThreadSafe();
+		Dispatching.invokeLaterOrNow(this, new Runnable() {
+			@Override
+			public void run() {
+				listeners.remove(listener);
+			}
+		});
+	}
+
+
+	protected void fireListChange(Path path, ListChange change) {
+		assert isActive();
+		for (InstanceListener l : this.listeners) {
 			l.onListChange(path, change);
 		}
 	}
 
-
-    public final FramsClass getInfoFromCache(Path path) {
-        return getInfoFromCache(path.getTop().getParam().getContainedTypeName());
-    }
-
-
-    public FramsClass getInfoFromCache(String id) {
-        assert isActive();
+	protected void fireFetch(Path path) {
+		assert isActive();
+		for (InstanceListener l : this.listeners) {
+			l.onFetch(path);
+		}
+	}
+
+
+	public final FramsClass getInfoFromCache(Path path) {
+		return getInfoFromCache(path.getTop().getParam().getContainedTypeName());
+	}
+
+
+	public FramsClass getInfoFromCache(String id) {
+		assert isActive();
 		return registry.getInfoFromCache(id);
 	}
@@ -137,211 +140,213 @@
 
 	public AccessInterface createAccess(String name) {
-        assert isActive();
-        if (name == null) {
+		assert isActive();
+		return registry.createAccess(name);
+	}
+
+
+	// TODO: make ValueParam
+	public <T> T get(Node node, Param childParam, Class<T> type) {
+		return bindAccess(node).get((ValueParam) childParam, type);
+	}
+
+	public void findInfo(final Path path, final Future<FramsClass> future) {
+		assert isActive();
+		final String name = path.getTop().getParam().getContainedTypeName();
+		final FramsClass framsClass = getInfoFromCache(name);
+		if (framsClass != null) {
+			log.trace("info for " + name + " found in cache");
+			future.result(framsClass, null);
+			return;
+		}
+		fetchInfo(path, future);
+	}
+
+	public final AccessInterface bindAccess(Node node) {
+		assert node.getObject() != null;
+		AccessInterface access = registry.prepareAccess(node.getParam());
+		if (access == null) {
+			log.error("missing access for: " + node.getParam());
 			return null;
 		}
-		FramsClass framsClass = getInfoFromCache(name);
-		if (framsClass == null) {
-			return null;
-		}
-
-		return registry.createAccess(name, framsClass);
-	}
-
-	public static AccessInterface wrapAccessWithListIfNeeded(CompositeParam param, AccessInterface access) {
-        if (access == null) {
-			return null;
-		}
-        return param.prepareAccessInterface(access);
-	}
-
-    public AccessInterface prepareAccess(CompositeParam param) {
-        return wrapAccessWithListIfNeeded(param, createAccess(param.getContainedTypeName()));
-    }
-
-    public <T> T get(Node node, Param childParam, Class<T> type) {
-        return bindAccess(node).get(childParam, type);
-    }
-
-    public void findInfo(final Path path, final Future<FramsClass> future) {
-        assert isActive();
-        final String name = path.getTop().getParam().getContainedTypeName();
-        final FramsClass framsClass = getInfoFromCache(name);
-        if (framsClass != null) {
-            LOGGER.trace("info for " + name + " found in cache");
-            future.result(framsClass, null);
-            return;
-        }
-        fetchInfo(path, future);
-    }
-
-    public final AccessInterface bindAccess(Node node) {
-        assert node.getObject() != null;
-        AccessInterface access = prepareAccess(node.getParam());
-        if (access == null) {
-			LOGGER.error("missing access for: " + node.getParam());
-            return null;
-        }
-        access.select(node.getObject());
-        return access;
-    }
-
-    public final <T> T getParam(Path path, String id, Class<T> type) {
-        return Casting.tryCast(type, prepareAccess(path.getTop().getParam()).getParam(id));
-    }
-
-    public final AccessInterface bindAccess(Path path) {
-        assert path.isResolved();
-        return bindAccess(path.getTop());
-    }
-
-    public void resolve(final String targetPath, final Future<Path> future) {
-        assert isActive();
-        final Path path = new Path(this, targetPath);
-        resolve(path, new Future<Path>() {
-            @Override
-            public void result(Path result, Exception e) {
-                assert isActive();
-                if (e != null) {
-                    future.result(path, e);
-                    return;
-                }
-                if (path.isResolved(targetPath)) {
-                    future.result(path, null);
-                    return;
-                }
-                if (path.isResolved()) {
-                    future.result(path, new Exception("testing"));
-                    return;
-                }
-                resolve(targetPath, future);
-            }
-        });
-    }
-
-    public void resolveAndFetch(final String targetPath, final Future<Path> future) {
-        assert isActive();
-        resolve(targetPath, new Future<Path>() {
-            @Override
-            public void result(final Path path, Exception e) {
-                if (e != null) {
-                    future.result(path, e);
-                    return;
-                }
-                assert path.isResolved(targetPath);
-                fetchValues(path, new StateFunctor() {
-                    @Override
-                    public void call(Exception e) {
-                        future.result(path, e);
-                    }
-                });
-            }
-        });
-    }
-
-    public Path createIfNeeded(String path) {
-        Path p;
-        while (!(p = new Path(this, path)).isResolved(path)) {
-            create(p);
-        }
-        return p;
-    }
-
-    public Path create(Path path) {
-        assert isActive();
-        assert !path.isResolved();
-        Path resolved = path.findResolution();
-        if (!resolved.isResolved()) {
-            LOGGER.debug("creating: " + path);
-            AccessInterface access = prepareAccess(path.getTop().getParam());
-            assert access != null;
-            Object child = access.createAccessee();
-            assert child != null;
-            if (path.size() == 1) {
-                root = new Node(root.getParam(), child);
-            } else {
-                bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
-            }
-            resolved = path.appendResolution(child);
-        }
-        tryRegisterOnChangeEvents(resolved);
-        return resolved;
-    }
-
-
-
-
-    public FramsClass processFetchedInfo(File file) {
-        assert isActive();
-        FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
-        if ("/".equals(file.getPath())) {
-            if (root.getParam().getContainedTypeName() == null) {
-                root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o " + framsClass.getId()).build(), root.getObject());
-            }
-        }
-        registry.putInfoIntoCache(framsClass);
-        return framsClass;
-    }
-
-    public void processFetchedValues(Path path, List<File> files) {
-        assert isActive();
-        assert files.size() == 1;
-        assert path.isTheSame(files.get(0).getPath());
-        Node node = path.getTop();
-        MultiParamLoader loader = new MultiParamLoader();
-        loader.setNewSource(files.get(0).getContent());
-        loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-
-        try {
-            if (node.getParam() instanceof ObjectParam) {
-                loader.addAccessInterface(bindAccess(node));
-                loader.go();
-    //            for (NodeListener l : listeners) {
-    //                l.onChange(this);
-    //            }
-                return;
-            }
-
-            ListAccess listAccess = ((ListAccess)bindAccess(node));
-            assert listAccess != null;
-            listAccess.clearValues();
-
-            AccessInterface elementAccess = listAccess.getElementAccess();
-            loader.addAccessInterface(elementAccess);
-            MultiParamLoader.Status status;
-            while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
-                if (status == MultiParamLoader.Status.AfterObject) {
-                    AccessInterface accessInterface = loader.getLastAccessInterface();
-
-                    String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
-                    Param param = new ParamBuilder().setType("o " + accessInterface.getId()).setId(id).build();
-                    Object child = accessInterface.getSelected();
-                    accessInterface.select(null);
-                    assert child != null;
-                    bindAccess(node).set(param, child);
-                }
-            }
-    //        for (NodeListener l : listeners) {
-    //            l.onChange(this);
-    //        }
-        } catch (Exception e) {
-            LOGGER.error("exception occurred while loading: " + e);
-        }
-
-    }
-
-    public static Iterator<String> splitPath(String path) {
-        List<String> list = new LinkedList<String>();
-        for (String s : path.split("/")) {
-            if (!s.isEmpty()) {
-                list.add(s);
-            }
-        }
-        return list.iterator();
-    }
+		access.select(node.getObject());
+		return access;
+	}
+
+	public final <T> T getParam(Path path, String id, Class<T> type) {
+		return Casting.tryCast(type, registry.prepareAccess(path.getTop().getParam()).getParam(id));
+	}
+
+	public final AccessInterface bindAccess(Path path) {
+		assert path.isResolved();
+		return bindAccess(path.getTop());
+	}
+
+	public void resolve(final String targetPath, final Future<Path> future) {
+		assert isActive();
+		final Path path = getPath(targetPath);
+		resolve(path, new Future<Path>() {
+			@Override
+			public void result(Path result, Exception e) {
+				assert isActive();
+				if (e != null) {
+					future.result(path, e);
+					return;
+				}
+				if (path.isResolved(targetPath)) {
+					future.result(path, null);
+					return;
+				}
+				if (path.isResolved()) {
+					future.result(path, new Exception("testing"));
+					return;
+				}
+				resolve(targetPath, future);
+			}
+		});
+	}
+
+	public void resolveAndFetch(final String targetPath, final Future<Path> future) {
+		assert isActive();
+		resolve(targetPath, new Future<Path>() {
+			@Override
+			public void result(final Path path, Exception e) {
+				if (e != null) {
+					future.result(path, e);
+					return;
+				}
+				assert path.isResolved(targetPath);
+				fetchValues(path, new StateFunctor() {
+					@Override
+					public void call(Exception e) {
+						future.result(path, e);
+					}
+				});
+			}
+		});
+	}
+
+	public Path createIfNeeded(String path) {
+		Path p;
+		while (!(p = getPath(path)).isResolved(path)) {
+			create(p);
+		}
+		return p;
+	}
+
+	public Path createIfNeeded(Path path) {
+		assert isActive();
+		if (path.isResolved()) {
+			return path;
+		}
+		return create(path);
+	}
+
+	public Path create(Path path) {
+		assert isActive();
+		assert !path.isResolved();
+		Path resolved = path.tryFindResolution();
+		if (!resolved.isResolved()) {
+			log.debug("creating: " + path);
+			AccessInterface access = registry.prepareAccess(path.getTop().getParam());
+			assert access != null;
+			Object child = access.createAccessee();
+			assert child != null;
+			if (path.size() == 1) {
+				root = new Node(root.getParam(), child);
+			} else {
+				bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
+			}
+			resolved = path.appendResolution(child);
+		}
+		tryRegisterOnChangeEvents(resolved);
+		return resolved;
+	}
+
+
+
+
+	public FramsClass processFetchedInfo(File file) {
+		assert isActive();
+		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
+		if ("/".equals(file.getPath())) {
+			if (root.getParam().getContainedTypeName() == null) {
+				root = new Node((CompositeParam)new ParamBuilder().setName("Instance").setId(name).setType("o " + framsClass.getId()).build(), root.getObject());
+			}
+		}
+		registry.putInfoIntoCache(framsClass);
+		return framsClass;
+	}
+
+	public void processFetchedValues(Path path, List<File> files) {
+		assert isActive();
+		assert files.size() == 1;
+		assert path.isTheSame(files.get(0).getPath());
+		Node node = path.getTop();
+		MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(files.get(0).getContent());
+		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+
+		try {
+			if (node.getParam() instanceof ObjectParam) {
+				loader.addAccessInterface(bindAccess(node));
+				loader.go();
+				fireFetch(path);
+	//            for (NodeListener l : listeners) {
+	//                l.onChange(this);
+	//            }
+				return;
+			}
+
+			ListAccess listAccess = ((ListAccess)bindAccess(node));
+			assert listAccess != null;
+			listAccess.clearValues();
+
+			AccessInterface elementAccess = listAccess.getElementAccess();
+			loader.addAccessInterface(elementAccess);
+			MultiParamLoader.Status status;
+			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
+				if (status == MultiParamLoader.Status.AfterObject) {
+					AccessInterface accessInterface = loader.getLastAccessInterface();
+
+					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
+					Param param = new ParamBuilder().setType("o " + accessInterface.getId()).setId(id).build();
+					Object child = accessInterface.getSelected();
+					accessInterface.select(null);
+					assert child != null;
+					bindAccess(node).set((ValueParam) param, child);
+				}
+			}
+
+			fireFetch(path);
+	//        for (NodeListener l : listeners) {
+	//            l.onChange(this);
+	//        }
+		} catch (Exception e) {
+			log.error("exception occurred while loading: " + e);
+		}
+
+	}
+
+	public static Iterator<String> splitPath(String path) {
+		List<String> list = new LinkedList<String>();
+		for (String s : path.split("/")) {
+			if (!s.isEmpty()) {
+				list.add(s);
+			}
+		}
+		return list.iterator();
+	}
 
 	public Registry getRegistry() {
 		return registry;
 	}
+
+	public Path getPath(String textual) {
+		return new Path(this, textual);
+	}
+
+	public Path getRootPath() {
+		return getPath("/");
+	}
 }
 
Index: java/main/src/main/java/com/framsticks/core/InstanceListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/InstanceListener.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/InstanceListener.java	(revision 84)
@@ -5,6 +5,7 @@
  */
 public interface InstanceListener {
-    public void onListChange(Path path, ListChange change);
-    public void onRun(Exception e);
-    public void onStop(Exception e);
+	public void onListChange(Path path, ListChange change);
+	public void onFetch(Path path);
+	public void onRun(Exception e);
+	public void onStop(Exception e);
 }
Index: java/main/src/main/java/com/framsticks/core/ListChange.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/ListChange.java	(revision 84)
@@ -2,12 +2,10 @@
 
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.ListSource;
 import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.types.DecimalParam;
 import com.framsticks.params.types.EnumParam;
 import com.framsticks.params.types.StringParam;
-import com.framsticks.util.Strings;
+import com.framsticks.util.lang.Strings;
 
-import java.util.ArrayList;
 import java.util.Arrays;
 
@@ -17,28 +15,28 @@
 public class ListChange {
 
-    public Action getAction() {
-        return action;
-    }
+	public Action getAction() {
+		return action;
+	}
 
-    public Integer getPosition() {
-        return position;
-    }
+	public Integer getPosition() {
+		return position;
+	}
 
-    public String getIdentifier() {
-        return identifier;
-    }
+	public String getIdentifier() {
+		return identifier;
+	}
 
-    public static enum Action {
-        Add,
-        Remove,
-        Modify
-    }
+	public static enum Action {
+		Add,
+		Remove,
+		Modify
+	}
 
-    private Action action;
-    private Integer position;
-    private String identifier;
+	private Action action;
+	private Integer position;
+	private String identifier;
 
-    public Integer getType() { return action.ordinal(); }
-    public void setType(Integer type) { action = Action.values()[type]; }
+	public Integer getType() { return action.ordinal(); }
+	public void setType(Integer type) { action = Action.values()[type]; }
 
 	public Integer getPos() { return position; }
@@ -48,26 +46,21 @@
 	public void setId(String id) { identifier = id; }
 
-    public String getBestIdentifier() {
-        if (Strings.notEmpty(identifier)) {
-            return identifier;
-        }
-        return position.toString();
-    }
+	public String getBestIdentifier() {
+		if (Strings.notEmpty(identifier)) {
+			return identifier;
+		}
+		return position.toString();
+	}
 
-    public static FramsClass getFramsClass() {
+	public static FramsClass getFramsClass() {
+		return new FramsClass("ListChange", "ListChange", null)
+				.append(new ParamBuilder().setId("type").setName("type").setType(new EnumParam(Arrays.asList("Add", "Remove", "Modify"))).build())
+				.append(new ParamBuilder().setId("id").setName("identifier").setType(StringParam.class).build())
+				.append(new ParamBuilder().setId("pos").setName("position").setType(DecimalParam.class).build());
+	}
 
-        ArrayList<String> actions = new ArrayList<String>();
-        actions.add("Add");
-        actions.add("Remove");
-        actions.add("Modify");
-        return new FramsClass("ListChange", "ListChange", null)
-                .append(new ParamBuilder().setId("type").setName("type").setType(new EnumParam(actions)).build())
-                .append(new ParamBuilder().setId("id").setName("identifier").setType(StringParam.class).build())
-                .append(new ParamBuilder().setId("pos").setName("position").setType(DecimalParam.class).build());
-    }
-
-    @Override
-    public String toString() {
-        return action + " " + identifier + " " + position;
-    }
+	@Override
+	public String toString() {
+		return action + " " + identifier + " " + position;
+	}
 }
Index: java/main/src/main/java/com/framsticks/core/LocalInstance.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/LocalInstance.java	(revision 84)
@@ -2,8 +2,7 @@
 
 import com.framsticks.hosting.InstanceClient;
-import com.framsticks.params.AccessInterface;
-import com.framsticks.params.Param;
-import com.framsticks.util.*;
-import com.framsticks.util.Thread;
+import com.framsticks.util.dispatching.Thread;
+
+import org.apache.commons.configuration.Configuration;
 import org.apache.log4j.Logger;
 
@@ -21,79 +20,72 @@
 public abstract class LocalInstance extends Instance {
 
-    private static final Logger LOGGER = Logger.getLogger(LocalInstance.class.getName());
+	private static final Logger log = Logger.getLogger(LocalInstance.class.getName());
 
-    public LocalInstance(Parameters parameters) {
-        super(parameters);
+	public LocalInstance() {
 
-        Integer accept = config.getInteger("accept", null);
-        if (accept != null) {
-            try {
-                acceptSocket = new ServerSocket();
-                acceptSocket.setReuseAddress(true);
-                acceptThread = new Thread(name + "-accept");
-                tryBind(accept);
-            } catch (IOException e) {
-                LOGGER.fatal("failed to create accept socket: " + e);
-            }
-        }
-    }
+	}
 
-    @Override
-    protected void run() {
-        super.run();
-    }
+	@Override
+	public void configure(Configuration config) {
+		Integer accept = config.getInteger("accept", null);
+		if (accept != null) {
+			try {
+				acceptSocket = new ServerSocket();
+				acceptSocket.setReuseAddress(true);
+				acceptThread = new Thread(name + "-accept");
+				tryBind(accept);
+			} catch (IOException e) {
+				log.fatal("failed to create accept socket: " + e);
+			}
+		}
+	}
 
-    @Override
-    protected void configure() throws Exception {
-        super.configure();
-    }
+	protected final Set<InstanceClient> clients = new HashSet<InstanceClient>();
+	ServerSocket acceptSocket;
+	Thread acceptThread;
 
-    protected final Set<InstanceClient> clients = new HashSet<InstanceClient>();
-    ServerSocket acceptSocket;
-    Thread acceptThread;
+	protected void acceptNext() {
+		acceptThread.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				try {
+					final Socket socket = acceptSocket.accept();
+					assert socket != null;
+					log.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
+					invokeLater(new Runnable() {
+						@Override
+						public void run() {
+							InstanceClient client = new InstanceClient(LocalInstance.this, socket);
+							clients.add(client);
+							log.info("client connected: " + client);
+						}
+					});
+				} catch (IOException e) {
+					log.error("failed to accept socket: " + e);
+				}
+				acceptNext();
+			}
+		});
+	}
 
-    protected void acceptNext() {
-        acceptThread.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                try {
-                    final Socket socket = acceptSocket.accept();
-                    assert socket != null;
-                    LOGGER.debug("accepted socket: " + socket.getInetAddress().getHostAddress());
-                    invokeLater(new Runnable() {
-                        @Override
-                        public void run() {
-                            InstanceClient client = new InstanceClient(LocalInstance.this, socket);
-                            clients.add(client);
-                            LOGGER.info("client connected: " + client);
-                        }
-                    });
-                } catch (IOException e) {
-                    LOGGER.error("failed to accept socket: " + e);
-                }
-                acceptNext();
-            }
-        });
-    }
-
-    public void tryBind(final Integer accept) {
-        acceptThread.invokeLater(new Runnable() {
-            @Override
-            public void run() {
-                try {
-                    acceptSocket.bind(new InetSocketAddress(accept));
-                    LOGGER.debug("started accepting on port " + accept);
-                    acceptNext();
-                } catch (IOException e) {
-                    LOGGER.fatal("failed to accept on port " + accept + ": " + e);
-                }
-                try {
-                    java.lang.Thread.sleep(1000);
-                } catch (InterruptedException ignored) {
-                }
-                tryBind(accept);
-            }
-        });
-    }
+	public void tryBind(final Integer accept) {
+		acceptThread.invokeLater(new Runnable() {
+			@Override
+			public void run() {
+				try {
+					acceptSocket.bind(new InetSocketAddress(accept));
+					log.debug("started accepting on port " + accept);
+					acceptNext();
+				} catch (IOException e) {
+					log.fatal("failed to accept on port " + accept + ": " + e);
+				}
+				try {
+					java.lang.Thread.sleep(1000);
+				} catch (InterruptedException ignored) {
+				}
+				tryBind(accept);
+			}
+		});
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/core/Node.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/Node.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/core/Node.java	(revision 84)
@@ -1,8 +1,5 @@
 package com.framsticks.core;
 
-import com.framsticks.params.types.CompositeParam;
-
-import java.util.HashMap;
-import java.util.Map;
+import com.framsticks.params.CompositeParam;
 
 /**
